/**
 * A simple ScreenManager class for 
 * your HTML5 apps.
 *
 * Author: Kushagra Gour @chinchang457
 */

// Click listener
$('body').on('click', function(e) {
  var screen = $(e.target).data('screen');
  
  if(screen) {
    game.ScreenManager.setScreen(screen);
  }
});

/**
 * SCREENMANGER Class
 */
(function(NS) {

  NS.ScreenManager = {};
  
	var _current_screen_name = '',
		_current_screen_node = null;

	NS.ScreenManager = {
		screens: ['menu', 'instructions', 'levels', 'credits','instructionss'],

		init: function (default_screen_name) {
			this.setScreen(default_screen_name);
		},

    /**
     * You can pass an optional callback to execute after screen set
     */
		setScreen: function(screen_name, callback) {
			if(typeof screen_name !== 'string' || _current_screen_name === screen_name) return;
			_current_screen_name = screen_name;
			// show the current screen
			$('.' + _current_screen_name).addClass('show').focus();

			// hide the rest of the screens
			// forming a class string using reduce function with all classes which
			// are equal to current screen
			$(this.screens.reduce(function(str, class_name) {
				return str + (class_name === _current_screen_name ? '' : ',.' + class_name);
			}, '').slice(1)).removeClass('show');
			if(callback) {
				callback.apply(this);
			}
		},

		getCurrentScreen: function() {
			return _current_screen_name;
		}
	};


})(window.game = window.game || {});

window.game.ScreenManager.init('menu');